【算法|贪心算法系列No.3】leetcode334. 递增的三元子序列

个人主页:兜里有颗棉花糖

欢迎 点赞👍 收藏✨ 留言✉ 加关注💓本文由 兜里有颗棉花糖 原创

收录于专栏【手撕算法系列专栏】【LeetCode】

🍔本专栏旨在提高自己算法能力的同时,记录一下自己的学习过程,希望对大家有所帮助

🍓希望我们一起努力、成长,共同进步。

点击直接跳转到该题目

目录

1️⃣题目描述

给你一个整数数组 nums ,判断这个数组中是否存在长度为 3 的递增子序列。

如果存在这样的三元组下标 (i, j, k) 且满足 i < j < k ,使得 nums[i] < nums[j] < nums[k] ,返回 true ;否则,返回 false 。

示例一:

输入:nums = 1,2,3,4,5

输出:true

解释:任何 i < j < k 的三元组都满足题意

示例二:

输入:nums = 5,4,3,2,1

输出:false

解释:不存在满足题意的三元组

示例三:

输入:nums = 2,1,5,0,4,6

输出:true

解释:三元组 (3, 4, 5) 满足题意,因为 nums3 == 0 < nums4 == 4 < nums5 == 6

注意:

  • 1 <= nums.length <= 5 * 105
  • -231 <= nums[i] <= 231 - 1

2️⃣题目解析

解题思路:

1.使用两个变量a和b来存储当前的最小值和次小值,初始时将a设置为数组中的第一个元素,将b设置为整型最大值。

2.遍历数组,对于每个元素numsi,判断它是否大于b。如果是,说明找到了递增的三元组,直接返回true。

3.如果numsi不大于b,则判断是否大于a。如果是,更新b为numsi,以保证b始终是当前的次小值。

4.如果numsi既不大于b,也不大于a,则将a更新为numsi,以保证a始终是当前的最小值。

如果遍历完整个数组都没有找到递增的三元组,则返回false。

本题的贪心策略贪心的核心思想是尽量保持a和b的值最小,以便有更大的机会找到递增的三元组。

3️⃣解题代码

cpp 复制代码
class Solution {
public:
    bool increasingTriplet(vector<int>& nums) {
        int a = nums[0];
        int b = INT_MAX;
        for(int i = 1;i < nums.size();i++)
        {
            if(nums[i] > b) return true;
            else if(nums[i] > a) b = nums[i];
            else a = nums[i];
        }
        return false;
    }
};
相关推荐
hold?fish:palm9 小时前
45 二叉树的右视图
开发语言·c++·算法
粤鼎恒业10 小时前
惠州工厂电子料回收厂家推荐:从交接单反推筛选标准
大数据·数据库·算法·硬件架构·硬件工程·pcb工艺·材料工程
小爷毛毛(卓寿杰)10 小时前
【Agent 意图识别】输出协议、评估与置信度
人工智能·算法·大模型·prompt·大语言模型·agent
优质酸酸乳10 小时前
力扣100题之21合并两个有序链表
算法·leetcode·链表
旖旎夜光10 小时前
LeetCode 137 : 只出现一次的数字 II(位运算) —— 题解
c++·笔记·学习·算法·leetcode·力控
旋生万物11 小时前
Agent System Prompt 注入螺旋公理:让 AI 推理不跑偏的可复制模板(附完整 Prompt)
人工智能·算法
深圳雨林凯AI11 小时前
图案裂变的空间关系原理:元素放大为何必然挤压负空间,以及三个可调变量|雨林凯AI技术拆解
人工智能·算法
tellmewhoisi11 小时前
机器学习:聚类算法
算法·机器学习·聚类
yi01112 小时前
LeetCode 134 加油站:从 双循环暴力 演变到 贪心
linux·算法·leetcode
sogw-三叶草️12 小时前
LeetCode 989. 数组形式的整数加法
数据结构·算法